#include "seller.h"

Seller::Seller() : Entity() {}

Seller::Seller(const std::string& firstName, const std::string& lastName, int sellerNo,
               int numberOfArticles)
    : Entity()
{
    firstName_ = firstName;
    lastName_ = lastName;
    sellerNo_ = sellerNo;
    numberOfOfferedArticles_ = numberOfArticles;
}

inline void Seller::setSellerNo(int seller_no) { sellerNo_ = seller_no; }

inline void Seller::setFirstName(const std::string& firstName) { firstName_ = firstName; }

inline void Seller::setLastName(const std::string& lastName) { lastName_ = lastName; }

inline void Seller::setNumberOfOfferedArticles(int number) { numberOfOfferedArticles_ = number; }

inline size_t Seller::getNumberOfOfferedArticles() { return articles_.size(); }

std::vector<Article> Seller::getArticles(bool onlySold) {
    if (onlySold) {
        std::vector<Article> soldArticles;
        for (auto article: articles_) {
            if (article.isSold()) {
                soldArticles.push_back(article);
            }
        }
        return soldArticles;
    } else {
        return articles_;
    }
}